/*
 *  Basic ankle movement behavior
 */

#include "ankle_behavior.h" 

DECLARE_CLASS(AnkleBehavior)

bool AnkleBehavior::behave( SideT side, AngDeg valueFront, AngDeg valueOpen, double dSpeed )
{
  bool bResult;

  if( dSpeed == -1 )
    dSpeed = static_gain;

  JointT joint = ( side == SIDE_LEFT ) ? ankleL : ankleR;
  AngDeg curAngle = WM->getJoint( joint ).getAxis();
  AngDeg angFront, angOpen;

  // First Front/Back
  if( fabs( curAngle - valueFront ) > static_maxError )
  {
    angFront = dSpeed * (valueFront - curAngle);
    bResult = false;
  }
  else
  {
    angFront = 0;
    bResult = true;
  }

  // Then Open/Close
  curAngle = WM->getJoint( joint ).getAxis2();
  if( fabs( curAngle - valueOpen ) > static_maxError )
  {
    angOpen = dSpeed * (valueOpen - curAngle);
    bResult &= false;
  }
  else
  {
    angOpen = 0;
    bResult &= true;
  }

  GetAdjustJointBehavior()->behave( joint, angFront, angOpen );
  return bResult;
}
