#ifndef ANKLE_BEHAVIOR_H_
#define ANKLE_BEHAVIOR_H_

#include "basic_behavior.h"
#include "behavior_constants.h"
#include "adjustjoint_behavior.h"

/*! This behavior changes the angle of shoulder, if currently value is near
    the current angle of hip then no changes are made
    \param side which leg to change angle
    \param valueFront new angle to change to 
    \param valueOpen new angle to change to
    \param dSpeed speed to set for action */
class AnkleBehavior: public BasicBehavior
{
protected:
    USE_MODULE(AdjustJointBehavior, "/Agent/Modules/Behaviour/AdjustJoint")
public:    
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( SideT side, AngDeg valueFront, AngDeg valueOpen, double dSpeed );
};

#endif /*ANKLE_BEHAVIOR_H_*/
