/*
*********************************************************************************
*                            In the name of Almighty                            *
*                                                                               *
*          BasicAgent.cpp : Robocup 3D Soccer Simulation Team Zigorat           *
*                     (This team was previously named Gcyrus)                   *
*                                                                               *
*  Date: 03/20/2007                                                             *
*  Author: Mahdi Hamdarsi                                                       *
*  Comments: This file contains class definition BasicAgent which contains      *
*            several routines needed for thinkin' module                        *
*                                                                               *
*********************************************************************************
*/

/*! \file BasicAgent.cpp
<pre>
<b>File:</b>          BasicAgent.cpp
<b>Project:</b>       Robocup Soccer Simulation Team: Zigorat
<b>Authors:</b>       Mahdi Hamdarsi
<b>Created:</b>       03/20/2007
<b>Last Revision:</b> $ID$
<b>Contents:</b>      This file contains class definition BasicAgent which contains
               several routines needed for thinkin' module
<hr size=2>
<h2><b>Changes</b></h2>
<b>Date</b>             <b>Author</b>          <b>Comment</b>
03/20/2007       Mahdi           Initial version created
</pre>
*/

#include "basic_behavior.h"
#include "../others/Logger.h"
#include "behavior_constants.h"
//#include "../others/globals.h"

DECLARE_CLASS(BasicBehavior)

TRoboCupConnection *BasicBehavior::connection;
ActHandler         *BasicBehavior::ACT;
WorldModel         *BasicBehavior::WM;

BasicBehavior::BasicBehavior()
{
  
}

BasicBehavior::~BasicBehavior()
{
  // nothing
}

void BasicBehavior::init(ActHandler * _ACT,WorldModel * _WM,TRoboCupConnection * _connection)
{
  // send info about agent
  ACT= _ACT;
  WM= _WM;
  connection= _connection;
  // send info about agent
  ACT->sendMessage( "(scene rsg/agent/soccerbot056.rsg)" );
  
}

/*! This method inits the agent for server by sending his name and number */
void BasicBehavior::sendPlayerInformation()
{
  char cmd[128];
  sprintf( cmd, "(init (unum %d)(teamname %s))", WM->getAgentNumber(), WM->getTeamName().c_str() );
  ACT->sendMessage( cmd );
}
