/*
*********************************************************************************
*                            In the name of Almighty                            *
*                                                                               *
*           BasicAgent.h : Robocup 3D Soccer Simulation Team Zigorat            *
*                     (This team was previously named Gcyrus)                   *
*                                                                               *
*  Date: 03/20/2007                                                             *
*  Author: Mahdi Hamdarsi                                                       *
*  Comments: This file contains class decleration BasicAgent which contains     *
*            several routines needed for thinkin' module                        *
*                                                                               *
*********************************************************************************
*/

/*! \file BasicAgent.h
<pre>
<b>File:</b>          BasicAgent.h
<b>Project:</b>       Robocup Soccer Simulation Team: Zigorat
<b>Authors:</b>       Mahdi Hamdarsi
<b>Created:</b>       03/20/2007
<b>Last Revision:</b> $ID$
<b>Contents:</b>      This file contains class decleration BasicAgent which contains
               several routines needed for thinkin' module
<hr size=2>
<h2><b>Changes</b></h2>
<b>Date</b>             <b>Author</b>          <b>Comment</b>
03/20/2007       Mahdi           Initial version created
</pre>
*/


#ifndef BASICAGENT_H
#define BASICAGENT_H

#include <string>
#include <vector>

#include "../others/ActHandler.h"
#include "../others/Connection.h"
#include "../others/WorldModel.h"
#include "behavior_storage.h"

/*! This class defines the skills that can be used by an agent. No
    functionality is available that chooses when to execute which skill, this
    is done in the Agent class. The WorldModel is used to determine the way
    in which the skills are performed. */
class BasicBehavior
{
protected:
    static TRoboCupConnection * connection;  /*!< Reference to Connection instance */
    static ActHandler         * ACT;         /*!< Reference to the ActHandler instance */
    static WorldModel         * WM;          /*!< Reference to WorldModle class */

    /// Initializing
    //void  InitializePlayerPosition();
    void  sendPlayerInformation();

public:
    static int inStorage;            /* if we're in mainStorage yet or not */

	  BasicBehavior();
	static void init(ActHandler * _ACT,WorldModel * _WM,TRoboCupConnection * _connection);
    virtual ~BasicBehavior();
};


#endif // BASICAGENT_H
