/*
 * Basic elbow behavior
 */

#include "elbow_behavior.h"

DECLARE_CLASS(ElbowBehavior)

bool ElbowBehavior::behave( SideT side, AngDeg value, double dSpeed )
{
  if( dSpeed == -1 )
    dSpeed = static_gain;

  JointT joint = ( side == SIDE_LEFT ) ? elbowL : elbowR;
  AngDeg curAngle = WM->getJoint( joint ).getAxis();

  if( fabs( curAngle - value ) > static_maxError )
  {
    GetAdjustJointBehavior()->behave( joint, dSpeed * (value - curAngle) );
    return false;
  }
  else
  {
    GetAdjustJointBehavior()->behave( joint, 0 );
    return false;
  }
}
