#ifndef ELBOW_BEHAVIOR_H_
#define ELBOW_BEHAVIOR_H_

#include "../others/SoccerTypes.h"
#include "basic_behavior.h"
#include "behavior_constants.h"
#include "adjustjoint_behavior.h"

/*! This behavior changes the angle of knee, if currently value is near
    the current angle of knee then no changes are made
    \param side which leg to change angle
    \param value new angle to change to
    \param dSpeed speed to set for action */
    
class ElbowBehavior: public BasicBehavior
{
protected:
    USE_MODULE(AdjustJointBehavior, "/Agent/Modules/Behaviour/AdjustJoint")
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( SideT side, AngDeg value, double dSpeed );
};

#endif /*ELBOW_BEHAVIOR_H_*/
