#ifndef HIP_BEHAVIOR_H_
#define HIP_BEHAVIOR_H_

#include "basic_behavior.h"
#include "behavior_constants.h"
#include "adjustjoint_behavior.h"

/*! This behavior changes the angle of hip, if currently value is near
    the current angle of hip then no changes are made
    \param side which leg to change angle
    \param valueFront New angle ( for moving the should towards front and back )
    \param valueOpen New angle ( for Opening and closing the arms )
    \param dSpeed speed to set for action */
    
class HipBehavior: public BasicBehavior
{
protected:
    USE_MODULE(AdjustJointBehavior, "/Agent/Modules/Behaviour/AdjustJoint")
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( SideT side, AngDeg valueFront, AngDeg valueOpen, double dSpeed );
};

#endif /*HIP_BEHAVIOR_H_*/
