/*
 * This file contains the basic knee behavior
 * 
 */

#include "knee_behavior.h"

DECLARE_CLASS(KneeBehavior)

bool KneeBehavior::behave( SideT side, AngDeg value, double dSpeed )
{
  if( dSpeed == -1 )
    dSpeed = static_gain;

  JointT joint = ( side == SIDE_LEFT ) ? kneeL : kneeR;
  AngDeg curAngle = WM->getJoint( joint ).getAxis();

  if( fabs( curAngle - value ) > static_maxError )
  {
    GetAdjustJointBehavior()->behave( joint, dSpeed * (value - curAngle) );
    return false;
  }
  else
  {
    GetAdjustJointBehavior()->behave( joint, 0 );
    return true;
  }
}
