/*
*********************************************************************************
*                            In the name of Almighty                            *
*                                                                               *
*            Agent.cpp : Robocup 3D Soccer Simulation Team Zigorat              *
*                     (This team was previously named Gcyrus)                   *
*                                                                               *
*  Date: 03/20/2007                                                             *
*  Author: Mahdi Hamdarsi                                                       *
*  Comments: This files contains class definition Agent which is the main       *
*            thinkin' module                                                    *
*                                                                               *
*********************************************************************************
*/

/*! \file Agent.cpp
<pre>
<b>File:</b>          Agent.cpp
<b>Project:</b>       Robocup Soccer Simulation Team: Zigorat
<b>Authors:</b>       Mahdi Hamdarsi
<b>Created:</b>       03/20/2007
<b>Last Revision:</b> $ID$
<b>Contents:</b>      This files contains class definition Agent which is the main
               thinkin' module
<hr size=2>
<h2><b>Changes</b></h2>
<b>Date</b>             <b>Author</b>          <b>Comment</b>
03/20/2007       Mahdi           Initial version created
</pre>
*/


#include "main_behavior.h"

DECLARE_CLASS(MainBehavior)

/******************************************************************************/
/*********************************  AGENT CLASS  ******************************/
/******************************************************************************/

MainBehavior::MainBehavior()
{
  // nothing
}

/*! This is the destructor of agent and currently does nothing. */
MainBehavior::~MainBehavior()
{
  // nothing
}

/*! This is the main loop of the agent. This method calls the update methods
    of the world model after it is indicated that new information has arrived.
    After this, the main thinkin' loop of the agent is called, which sends 
    the best command according to his/her! simple mind :) to the server. */
void MainBehavior::mainLoop()
{
  char strServerMsg[2048], *strMsg;
  while( connection->getMessage( strServerMsg, 2047 ) )
  {
    if( WM->getCurrentCycle() == 0 )
      sendPlayerInformation();
    else if( WM->getCurrentCycle() == 1 )
      GetInitPosBehavior()->behave();

    strMsg = strServerMsg;
    WM->updateFromServerMsg(&strMsg);
    makeDecision();
    ACT->sendCommands();
  }
}

/*! This method is the first complete simple agent and defines the actions
    taken by the agent. It is based on highlevel actions which are goin' to
    be coded. */
void MainBehavior::deMeer5()
{
  static bool start = true;
  static int  iStep = 1;
  static Time time = WM->getSimulatorTime();

  if( WM->getSimulatorTime() - time < 2 )
    return;

  if( iStep == 1 )
  {
    if( GetTurnToBehavior()->behave( 90, start ) )
    {
      iStep++;
      start = true;
    }
    else
      return; 
  }
  
  GetWalkBehavior()->behave( start );
}

