/*
*********************************************************************************
*                            In the name of Almighty                            *
*                                                                               *
*             Agent.h : Robocup 3D Soccer Simulation Team Zigorat               *
*                     (This team was previously named Gcyrus)                   *
*                                                                               *
*  Date: 03/20/2007                                                             *
*  Author: Mahdi Hamdarsi                                                       *
*  Comments: This files contains class decleration Agent which is the main      *
*            thinkin' module                                                    *
*                                                                               *
*********************************************************************************
*/

/*! \file Agent.h
<pre>
<b>File:</b>          Agent.h
<b>Project:</b>       Robocup Soccer Simulation Team: Zigorat
<b>Authors:</b>       Mahdi Hamdarsi
<b>Created:</b>       03/20/2007
<b>Last Revision:</b> $ID$
<b>Contents:</b>      This files contains class decleration Agent which is the main
               thinkin' module
<hr size=2>
<h2><b>Changes</b></h2>
<b>Date</b>             <b>Author</b>          <b>Comment</b>
03/20/2007       Mahdi           Initial version created
</pre>
*/

#ifndef AGENT_H
#define AGENT_H

#include "basic_behavior.h"
#include "initpos_behavior.h"
#include "turnto_behavior.h"
#include "walk_behavior.h"

/******************************************************************************/
/*********************************  AGENT CLASS  ******************************/
/******************************************************************************/


/*! This class is a superclass from BasicPlayer and contains a more
    sophisticated decision procedure to determine the next action. */
class MainBehavior : public BasicBehavior
{
protected:
    USE_MODULE(InitPosBehavior, "/Agent/Modules/Behaviour/InitPos")
    USE_MODULE(TurnToBehavior, "/Agent/Modules/Behaviour/TurnTo")
    USE_MODULE(WalkBehavior, "/Agent/Modules/Behaviour/Walk")
  
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    MainBehavior();
    virtual ~MainBehavior();
    void mainLoop();

    void deMeer5();
    void makeDecision();
};

#endif
