/*
 *  Basic arm rotation behavior
 */
 
#include "rotatearm_behavior.h"

DECLARE_CLASS(RotateArmBehavior)

bool RotateArmBehavior::behave( SideT side, AngDeg value, double dSpeed )
{
  if( dSpeed == -1 )
    dSpeed = static_gain;

  JointT joint = ( side == SIDE_LEFT ) ? JID_LARM_3 : JID_RARM_3;
  AngDeg curAngle = WM->getJoint( joint ).getAxis();

  if( fabs( curAngle - value ) > static_maxError )
  {
    GetAdjustJointBehavior()->behave( joint, dSpeed * (value - curAngle) );
    return false;
  }
  else
  {
    GetAdjustJointBehavior()->behave( joint, 0 );
    return true;
  }
}
