#ifndef ROTATEARM_BEHAVIOR_H_
#define ROTATEARM_BEHAVIOR_H_

#include "basic_behavior.h"
#include "behavior_constants.h"
#include "adjustjoint_behavior.h"

/*! This behavior changes the angle of First joint of arm(Shoulder), if
    currently value is near the current angle of knee then no changes
    are made.
    \param side which leg to change angle
    \param value new angle to change to
    \param dSpeed speed to set for action */
    
class RotateArmBehavior: public BasicBehavior
{
protected:
    USE_MODULE(AdjustJointBehavior, "/Agent/Modules/Behaviour/AdjustJoint")
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( SideT side, AngDeg value, double dSpeed );
};

#endif /*ROTATEARM_BEHAVIOR_H_*/
