/*
 *  Basic leg rotation behavior
 */
 
#include "rotateleg_behavior.h"

DECLARE_CLASS(RotateLegBehavior)

bool RotateLegBehavior::behave( SideT side, AngDeg value, double dSpeed )
{
  if( dSpeed == -1 )
    dSpeed = static_gain;

  JointT joint = ( side == SIDE_LEFT ) ? JID_LLEG_1 : JID_RLEG_1;
  AngDeg curAngle = WM->getJoint( joint ).getAxis();

  if( fabs( curAngle - value ) > static_maxError )
  {
    GetAdjustJointBehavior()->behave( joint, dSpeed * (value - curAngle) );
    return false;
  }
  else
  {
    GetAdjustJointBehavior()->behave( joint, 0 );
    return true;
  }
}

