#ifndef ROTATELEG_BEHAVIOR_H_
#define ROTATELEG_BEHAVIOR_H_

#include "basic_behavior.h"
#include "behavior_constants.h"
#include "adjustjoint_behavior.h"

/*! This behavior changes the angle of First joint of leg (Hip), if
    currently  value  is near the  current angle of  knee then no 
    changes are made.
    \param side which leg to change angle
    \param value new angle to change to
    \param dSpeed speed to set for action */
    
class RotateLegBehavior: public BasicBehavior
{
protected:
    USE_MODULE(AdjustJointBehavior, "/Agent/Modules/Behaviour/AdjustJoint")
public:   
	static int inStorage;            /* if we're in mainStorage yet or not */ 
    virtual bool behave( SideT side, AngDeg value, double dSpeed );
};

#endif /*ROTATELEG_BEHAVIOR_H_*/
