#ifndef TURNTO_BEHAVIOR_H_
#define TURNTO_BEHAVIOR_H_

#include "basic_behavior.h"
#include "turntoleft_behavior.h"
#include "turntoright_behavior.h"

/*! This behavior turns the agent to a desired angle by selecting
    the way agent should turn; ie. with his left leg or right one.
    \param ang Desired angle to turn the agent to
    \param start static value to synchronize moves
*/

class TurnToBehavior: public BasicBehavior
{
protected:
    USE_MODULE(TurnToLeftBehavior, "/Agent/Modules/Behaviour/TurnToLeft")
    USE_MODULE(TurnToRightBehavior, "/Agent/Modules/Behaviour/TurnToRight")
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( AngDeg ang, bool &start );
};

#endif /*TURNTO_BEHAVIOR_H_*/
