/*
 *  Basic right-turn behavior [zigorat, not to be used]
 */
 
#include "turntoright_behavior.h"

DECLARE_CLASS(TurnToRightBehavior)

bool TurnToRightBehavior::behave( AngDeg ang, bool & start )
{
  double gain = 0.02;

  static Time time;
  if( start )
  {
    start = false;
    time  = WM->getSimulatorTime();
  }

  if( WM->getSimulatorTime() - time < 2 )
  {
    return false;
  }
  else if( ( WM->getSimulatorTime() - time ) < 3 )
  {
    // In this step which takes 1 second, agent turns his right ankle ( 25 degs & 5 gains ),
    // & bending his left hip ( 12 degrees & 1 gain ) so that she (the agent :) )
    // keeps her weight in balance

    // Left Part Configuration                                  // Right Part Configuration
    GetShoulderBehavior()->behave( SIDE_LEFT,    0,    0, 1.50 * gain );    GetShoulderBehavior()->behave( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetHipBehavior()->behave     ( SIDE_LEFT,    0,    0, 1.50 * gain );    GetHipBehavior()->behave     ( SIDE_RIGHT,    0,  -10, 1.50 * gain );
    GetAnkleBehavior()->behave   ( SIDE_LEFT,    0,   25, 5.00 * gain );    GetAnkleBehavior()->behave   ( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetKneeBehavior()->behave    ( SIDE_LEFT,    0,       1.00 * gain );    GetKneeBehavior()->behave    ( SIDE_RIGHT,    0,       1.00 * gain );
    GetElbowBehavior()->behave   ( SIDE_LEFT,    0,       1.00 * gain );    GetElbowBehavior()->behave   ( SIDE_RIGHT,    0,       1.00 * gain );
    return false;
  }
  else if( ( WM->getSimulatorTime() - time ) < 7 )
  {
    // In this step agent stops pushing from the opposite foot also he exerts a little
    // force by the ankle of following leg ankle ( 5 degs and 1 gain ) to stop free
    // falling into the unknown! ; also mentioning the role of left hip in
    // controling the balance ( 15 degs & 1 gain )
    // Left Part Configuration                                  // Right Part Configuration
    GetShoulderBehavior()->behave( SIDE_LEFT,    0,    0, 1.00 * gain );    GetShoulderBehavior()->behave( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetHipBehavior()->behave     ( SIDE_LEFT,    0,    0, 1.00 * gain );    GetHipBehavior()->behave     ( SIDE_RIGHT,    0,  -12, 1.50 * gain );
    GetAnkleBehavior()->behave   ( SIDE_LEFT,    0,    0, 1.00 * gain );    GetAnkleBehavior()->behave   ( SIDE_RIGHT,    0,   -5, 1.00 * gain );
    GetKneeBehavior()->behave    ( SIDE_LEFT,    0,       1.00 * gain );    GetKneeBehavior()->behave    ( SIDE_RIGHT,    0,       1.00 * gain );
    GetElbowBehavior()->behave   ( SIDE_LEFT,    0,       1.00 * gain );    GetElbowBehavior()->behave   ( SIDE_RIGHT,    0,       1.00 * gain );
    return false;
  }
  else if( WM->getSimulatorTime() - time < 8.5 )
  {
    // In this step agent stabilizes its weight on foot by changing the left hip angle
    // ( 15 degs & 1 gain ), also changing his left ankle angle by ( -7 degs & 1 gain )
    // and of course changing right hip angle by ( -10 degs & -10 degs & 1 gain )

    // At last he changes his own bodies angle by rotating a leg which is attached to ground

    // Left Part Configuration                                  // Right Part Configuration
    GetShoulderBehavior()->behave( SIDE_LEFT,    0,    0, 1.00 * gain );    GetShoulderBehavior()->behave( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetHipBehavior()->behave     ( SIDE_LEFT,  -10,   10, 1.00 * gain );    GetHipBehavior()->behave     ( SIDE_RIGHT,    0,  -15, 1.00 * gain );
    GetAnkleBehavior()->behave   ( SIDE_LEFT,    8,    0, 1.00 * gain );    GetAnkleBehavior()->behave   ( SIDE_RIGHT,    0,   10, 2.00 * gain );
    GetKneeBehavior()->behave    ( SIDE_LEFT,    0,       1.00 * gain );    GetKneeBehavior()->behave    ( SIDE_RIGHT,    0,       1.00 * gain );
    GetElbowBehavior()->behave   ( SIDE_LEFT,    0,       1.00 * gain );    GetElbowBehavior()->behave   ( SIDE_RIGHT,    0,       1.00 * gain );

    GetRotateLegBehavior()->behave( SIDE_RIGHT, -ang, gain );
    return false;
  }
  else if( WM->getSimulatorTime() - time < 12)
  {
    // In this last step agent stabilizes its weight on both feet by re-initializing
    // almost all joints to 0 degrees

    // Left Part Configuration                                  // Right Part Configuration
    GetShoulderBehavior()->behave( SIDE_LEFT,    0,    0, 1.00 * gain );    GetShoulderBehavior()->behave( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetHipBehavior()->behave     ( SIDE_LEFT,    0,    0, 1.00 * gain );    GetHipBehavior()->behave     ( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetAnkleBehavior()->behave   ( SIDE_LEFT,    0,    0, 1.00 * gain );    GetAnkleBehavior()->behave   ( SIDE_RIGHT,    0,    0, 1.00 * gain );
    GetKneeBehavior()->behave    ( SIDE_LEFT,    0,       1.00 * gain );    GetKneeBehavior()->behave    ( SIDE_RIGHT,    0,       1.00 * gain );
    GetElbowBehavior()->behave   ( SIDE_LEFT,    0,       1.00 * gain );    GetElbowBehavior()->behave   ( SIDE_RIGHT,    0,      1.00 * gain );

    GetRotateLegBehavior()->behave( SIDE_RIGHT, 0, 3 * gain );
    return false;
  }

  return true;
}
