#ifndef TURNTORIGHT_BEHAVIOR_H_
#define TURNTORIGHT_BEHAVIOR_H_

#include "basic_behavior.h"
#include "shoulder_behavior.h"
#include "hip_behavior.h"
#include "ankle_behavior.h"
#include "knee_behavior.h"
#include "elbow_behavior.h"
#include "rotateleg_behavior.h"

/*! This behavior turn the agent to gain the angle requested,
    First Agent moves its weight on his first foot, then rotates, then
    puts its weigth on the other foot and at last finishes turning.
    \param ang Angle to turn to
    \param start sets weather this should be the first call of this method
    \return bool true indicates that turning is finished
*/

class TurnToRightBehavior: public BasicBehavior
{
protected:
    USE_MODULE(ShoulderBehavior, "/Agent/Modules/Behaviour/Shoulder")
    USE_MODULE(HipBehavior, "/Agent/Modules/Behaviour/Hip")
    USE_MODULE(AnkleBehavior, "/Agent/Modules/Behaviour/Ankle")
    USE_MODULE(KneeBehavior, "/Agent/Modules/Behaviour/Knee")
    USE_MODULE(ElbowBehavior, "/Agent/Modules/Behaviour/Elbow")
    USE_MODULE(RotateLegBehavior, "/Agent/Modules/Behaviour/RotateLeg")
public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( AngDeg ang, bool & start );
};

#endif /*TURNTORIGHT_BEHAVIOR_H_*/
