#ifndef WALK_BEHAVIOR_H_
#define WALK_BEHAVIOR_H_

#include "basic_behavior.h"
#include "shoulder_behavior.h"
#include "hip_behavior.h"
#include "ankle_behavior.h"
#include "knee_behavior.h"
#include "elbow_behavior.h"
#include "rotateleg_behavior.h"

/*! This method is used to walk the agent
    \param start boolean vlaue which synchronizes agents movements
    \return bool indicating wheather moving is finished
*/

class WalkBehavior: public BasicBehavior
{
protected:
    USE_MODULE(ShoulderBehavior, "/Agent/Modules/Behaviour/Shoulder")
    USE_MODULE(HipBehavior, "/Agent/Modules/Behaviour/Hip")
    USE_MODULE(AnkleBehavior, "/Agent/Modules/Behaviour/Ankle")
    USE_MODULE(KneeBehavior, "/Agent/Modules/Behaviour/Knee")
    USE_MODULE(ElbowBehavior, "/Agent/Modules/Behaviour/Elbow")
    USE_MODULE(RotateLegBehavior, "/Agent/Modules/Behaviour/RotateLeg")

public:
	static int inStorage;            /* if we're in mainStorage yet or not */
    virtual bool behave( bool & start );
};

#endif /*WALK_BEHAVIOR_H_*/
